//FILE: libgomd.cpp
//PURPOSE: define an interface for both main.cpp and libgomd.cpp
//         (so main.cpp will know what to load)
//AUTHOR: Gian Paolo Ghilardi, a.k.a. rejected || jp
//MAIL: (jp80@tin.it)

#ifndef LGOMD_HPP
#define LGOMD_HPP

	//The iface defines exactly what to load at runtime.
	class lgomd
	{
		public: //vars
			int m_id;

		public: //functions


			//constructor (sets an ID for the class)
			lgomd() : m_id(1234) {}

			//this is a virtual method: child classes must implement the code
			virtual void getLoad( int nodeId ){}

	};

	// Some nice typedef used in main.cpp to create an object and kill it
	// in the most intuitive way
	typedef lgomd* create_t();
	typedef void destroy_t(lgomd*);

#endif //end of LGOMD_HPP
