//FILE: libgomd.cpp
//PURPOSE: implement a simple class library loaded dynamically at runtime by a program
//AUTHOR: Gian Paolo Ghilardi, a.k.a. rejected || jp
//MAIL: (jp80@tin.it)

//TO COMPILE: g++ libgomd.cpp  -o libgomd.so -shared

#include "lgomd.hpp"
#include <iostream>

using namespace std;

class libgomd : public lgomd //extends the lgmod interface
{
	public:
		void getLoad( int nodeId);
};

//getLoad method definition (was set as "virtual" in lgomd)
void libgomd::getLoad( int nodeId)
{
	cout << "- Load of node #" << nodeId << " is " <<((float)nodeId/10.0) << endl;
}
/*  End of Class definition*/




//functions called by the dynamic library loader
//NOTE: these two functions are declared as 'extern "C"' so they can be
//called by Linux's standard library loading functions (dlopen,dlsym,dlclose,dlerror)
extern "C" lgomd* create()
{
	//HERE IS THE TRICK: we return a class!!! :)
	return new libgomd; //returns a new instance of the libgomd class to the caller
}

extern "C" void destroy(lgomd* instance)
{
	delete instance; //kills a valid libgomd instance
}
